// -----------------------------------------------------------------------------------------
//
// Riese4.CS                                                          Ulrich Mller 27.05.04
//                                                                    PCS1700       C# Final
// Betriebsprogramm Riesenrad Schritt 4 : Echt-Betrieb - WaitForChange
// Basis Assembly FishFa30.DLL / umFish30.DLL
//
// -----------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace RiesenBetrieb
{
	public class Riese4CS : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label label1;
	
		// --- FishFace : Klassen-Instanz ----------------------------------------
		private FishFace ft = new FishFace(true, false, 0);
		const int mRadMotor = (int)Nr.M1, eRadPos = (int)Nr.E2, eQuittung = (int)Nr.E1,
			cLinks = (int)Dir.Links, cRechts = (int)Dir.Rechts, cAus = (int)Dir.Aus;
		private System.Windows.Forms.NumericUpDown nudRunden;

		private System.ComponentModel.Container components = null;

		// --- Konstruktor / Destruktor ------------------------------------------

		public Riese4CS()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )	{
			  if (components != null) {
				components.Dispose();
			  }
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.nudRunden = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.nudRunden)).BeginInit();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(40, 104);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(216, 32);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&ACTION";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(256, 24);
			this.lblStatus.TabIndex = 1;
			this.lblStatus.Text = "Status";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(112, 72);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Anzahl Runden";
			// 
			// nudRunden
			// 
			this.nudRunden.Location = new System.Drawing.Point(40, 72);
			this.nudRunden.Minimum = new System.Decimal(new int[] {
																	  1,
																	  0,
																	  0,
																	  0});
			this.nudRunden.Name = "nudRunden";
			this.nudRunden.Size = new System.Drawing.Size(64, 20);
			this.nudRunden.TabIndex = 3;
			this.nudRunden.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nudRunden.Value = new System.Decimal(new int[] {
																	5,
																	0,
																	0,
																	0});
			// 
			// Riese4CS
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 159);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.nudRunden,
																		  this.label1,
																		  this.lblStatus,
																		  this.cmdAction});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Riese4CS";
			this.Text = "Riesenrad Schritt 4";
			((System.ComponentModel.ISupportInitialize)(this.nudRunden)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		// --- Haupteinstiegspunkt fr die Anwendung -------------------------------

		[STAThread]
		static void Main() 
		{
			Application.Run(new Riese4CS());
		}

		// --- Zentrale Betriebsroutine -------------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try	
			{
				ft.OpenInterface(Port.COM2);
				while (!ft.Finish(Nr.E1)) {
					lblStatus.Text = "--- Aus- und Einsteigen ---";
					for(int i = 1; i <= 6; i++) {
						ft.SetMotor(mRadMotor, cLinks);
						ft.WaitForHigh(eRadPos);
						ft.Pause(1500);
						ft.SetMotor(mRadMotor, cAus);
						lblStatus.Text = "Gondel : " + i.ToString();
						ft.WaitForLow(eQuittung);
					}
					lblStatus.Text = "Fahrbetrieb : Quittungs-Taster";
					ft.Pause(3000);
					if (!ft.GetInput(eQuittung)) ft.NotHalt = true;
					ft.SetMotor(Nr.M1, Dir.Links);
					for(int i = 1; i <= (int)nudRunden.Value; i++) {
						lblStatus.Text = "--- Runde : " + i.ToString() + " linksrum ---";
						ft.WaitForChange(eRadPos, 12);
					}
					ft.SetMotor(mRadMotor, cAus);
					ft.Pause(1000);
					ft.SetMotor(mRadMotor, cRechts);
					for(int i = 1; i <= (int)nudRunden.Value; i++) {
						lblStatus.Text = "--- Runde : " + i.ToString() + " rechtsrum ---";
						ft.WaitForChange(eRadPos, 12);
					}
					ft.SetMotor(mRadMotor, cAus);
					ft.Pause(1000);
				}
				lblStatus.Text = "--- Betrieb beendet ---";
			}
			catch(FishFaceException eft) 
			{
				lblStatus.Text = eft.Message;
			}
			finally	
			{
				ft.CloseInterface();
			}
		}
	}
}
